//=============================================================================
//
//  CLASS Light
//
//=============================================================================
#ifndef RAYTRACER_LIGHT_H
#define RAYTRACER_LIGHT_H

//== INCLUDES =================================================================
#include "Types.h"
#include "Ray.h"
#include <QGLWidget>

//== CLASS DEFINITION =========================================================
class   Light
{

    //-------------------------------------------------------------- typedefs
public:

    //-------------------------------------------------------------- private data
private:

    //-------------------------------------------------------------- private methods
private:

public:

    //-------------------------------------------------------------- constructors

    //! standard constructor
    Light()
    {
    };

    //! destructor	
    ~Light()
    {
    };

    //----------------------------------------------------------- functionality
public:

    /*!
		get a ray to light source and its valid domain and intensity of the light source.
		
		\param uiNumSample Reserved for Monte-Carlo raytracing.
	*/
    virtual void    shadowFeeler( Ray             &clRay,
                                  double        &rRayDomain,
                                  ColorType       &colIntensity ) const = 0;

    //! render Light in OpengL.
    virtual void    renderGL( GLint number ) const = 0;
};
//=============================================================================
#endif // RAYTRACER_LIGHT_H
