//=============================================================================
//
//  CLASS PointLight
//
//=============================================================================
#ifndef RAYTRACER_POINTLIGHT_H
#define RAYTRACER_POINTLIGHT_H

//== INCLUDES =================================================================
#include "Light.h"

//== CLASS DEFINITION =========================================================

/*!
	PointLight
	
	\author Gero Mller
*/
class PointLight : public Light
{

    //-------------------------------------------------------------- private data
private:
    VectorType3 m_v3Position;
    ColorType   m_colIntensity;


public:

    //-------------------------------------------------------------- constructors

    //! standard constructor
    PointLight()
    {
    };

    //! initializing constructor
    PointLight(
        const VectorType3   &v3Position,    
        const ColorType     &colIntensity )  :
    m_v3Position( v3Position ),
    m_colIntensity( colIntensity )
    {
    };

    //! destructor	
    ~PointLight()
    {
    };

    //----------------------------------------------------------- access elements
    void setPosition(
        const VectorType3   &v3Position )   
    {
        m_v3Position = v3Position;
    };

    
    const VectorType3 &getPosition() const
    {
        return m_v3Position;
    };

    
    void setIntensity(
        const ColorType &colIntensity ) 
    {
        m_colIntensity = colIntensity;
    };

    
    const ColorType &getIntensity() const
    {
        return m_colIntensity;
    };

    //----------------------------------------------------------- functionality
public:
    void    shadowFeeler( Ray             &clRay,
                          double        &rRayDomain,
                          ColorType       &colIntensity ) const;
    void    renderGL( GLint number ) const;
};

//=============================================================================
#endif // RAYTRACER_POINTLIGHT_H
